/* ARMGDB stub @ˑ֐Q*/

#include <gdb-stub-common.h>
#include "gdb-stub.h"

#define UART_BAUDRATE 19200
#define USE_INTERNAL_RAM

// GDBɒʒmVOiԂ֐B
int computeSignal (int exceptionVector)
{
  int sigval;

  switch (exceptionVector)
    {
    case NO_EXCEPTION:
      sigval = -1;
      break;
    case EXCEPTION_ILL_INSN:
      sigval = TARGET_SIGNAL_ILL;
      break;
    case EXCEPTION_PREFETCH_ABORT:
    case EXCEPTION_DATA_ABORT:
      sigval = TARGET_SIGNAL_BUS;
      break;
    case EXCEPTION_SOFTWARE:
      sigval = TARGET_SIGNAL_TRAP;
      break;
    case EXCEPTION_IRQ:
    case EXCEPTION_FIQ:
      sigval = TARGET_SIGNAL_INT;
      break;
    case TERM_EXCEPTION:
      sigval = TARGET_SIGNAL_TERM;
      break;
    default:
      sigval = 7;               /* "software generated"*/
      break;
    }
  return (sigval);

}

// UART̎Mf[^ۂɂ
void clear_uart(){

}

#define MMR_BASE 0xFFFF0000

#define GP0CON *((volatile unsigned int *)(MMR_BASE + 0xF400))
#define GP1CON *((volatile unsigned int *)(MMR_BASE + 0xF404))
#define GP2CON *((volatile unsigned int *)(MMR_BASE + 0xF408))
#define GP3CON *((volatile unsigned int *)(MMR_BASE + 0xF40C))
#define GP4CON *((volatile unsigned int *)(MMR_BASE + 0xF410))

#define COMTX *((volatile unsigned char *)(MMR_BASE + 0x0700))
#define COMRX *((volatile unsigned char *)(MMR_BASE + 0x0700))
#define COMDIV0 *((volatile unsigned char *)(MMR_BASE + 0x0700))
#define COMDIV1 *((volatile unsigned char *)(MMR_BASE + 0x0704))
#define COMCON0 *((volatile unsigned char *)(MMR_BASE + 0x070C))
#define COMSTA0 *((volatile unsigned char *)(MMR_BASE + 0x0714))

#define COMIEN0 *((volatile unsigned char *)(MMR_BASE + 0x0704))
#define COMIID0 *((volatile unsigned char *)(MMR_BASE + 0x0708))

#define POWKEY1 *((volatile unsigned short *)(MMR_BASE + 0x0404))
#define POWCON *((volatile unsigned short *)(MMR_BASE + 0x0408))
#define POWKEY2 *((volatile unsigned short *)(MMR_BASE + 0x040C))

#define XMCFG  *((volatile unsigned char *)(MMR_BASE + 0xF000))
#define XM0CON *((volatile unsigned char *)(MMR_BASE + 0xF010))
#define XM1CON *((volatile unsigned char *)(MMR_BASE + 0xF014))
#define XM2CON *((volatile unsigned char *)(MMR_BASE + 0xF018))
#define XM3CON *((volatile unsigned char *)(MMR_BASE + 0xF01C))
#define XM0PAR *((volatile unsigned short *)(MMR_BASE + 0xF020))
#define XM1PAR *((volatile unsigned short *)(MMR_BASE + 0xF024))
#define XM2PAR *((volatile unsigned short *)(MMR_BASE + 0xF028))
#define XM3PAR *((volatile unsigned short *)(MMR_BASE + 0xF02C))

#define IRQEN *((volatile unsigned short *)(MMR_BASE + 0x0008))

#define T3LD *((volatile unsigned short *)(MMR_BASE + 0x0360))
#define T3VAL *((volatile unsigned short *)(MMR_BASE + 0x0364))
#define T3CON *((volatile unsigned short *)(MMR_BASE + 0x0368))
#define T3CLRI *((volatile unsigned char *)(MMR_BASE + 0x036C))

/* M荞݋ */
void enable_int(){
  // UARTIRQLɂ
  IRQEN |= (1<<14);

  //  COMCON0 &= ~(1<<7);
  //  COMIEN0 |= 1; // set ERBFI
}

/* M荞݋֎~ */
void disable_int(){
  // UARTIRQ𖳌ɂ
  IRQEN &= ~(1<<14);

  //  COMCON0 &= ~(1<<7);
  //  COMIEN0 &= ~1; // reset ERBFI
}

void gdb_stub_kill_command(){
  // EHb`hbN^C}[ŃtZbg
  T3CLRI = 1;
  T3LD = 0x7FFF;
  T3CON = (1<<5)|(1<<7);
}

// GDBgVA|[g܂B
void init_serial (){
  // UARTȉ̂悤ɐݒ
  // Data : 8bit
  // Parity : Ȃ
  // Stop bit : 1bit
  switch(UART_BAUDRATE){
  case 19200 :
    // ̏ꍇACD0ADL44hƂĐݒ肷B
    // DLݒ
    COMCON0 |= (1<<7);
    COMDIV0 = 0x44;
    COMDIV1 = 0x00;
    // CDݒ
    POWKEY1 = 0x01;
    POWCON = 0x00;
    POWKEY2 = 0xF4;
    break;
  case 9600 :
  default :
    // ̏ꍇACD3ADL11hƂĐݒ肷B
    // DLݒ
    COMCON0 |= (1<<7);
    COMDIV0 = 0x11;
    COMDIV1 = 0x00;
    // CDݒ
    POWKEY1 = 0x01;
    POWCON = 0x03;
    POWKEY2 = 0xF4;
    break;
  }
  // COMDIV0ACOMDIV1̐ݒLɂāAf[^8rbgɐݒ
  COMCON0 = (0x3<<0);
  
  // GPIOUART[hɐݒ肵܂B
  //  GP0CON = 0x10000000;
  //GP1CON = 0x11111111;
  //  GP2CON = 0x00000001;

  GP1CON = (GP1CON & ~0xFF) | 0x11;

  COMCON0 &= ~(1<<7);
  COMIEN0 |= 1; // set ERBFI

}

// VA|[gAGDB̃R}h󂯎܂B
// 1oCgԂ܂B
char getDebugChar (void){
  volatile int c;
  while ((COMSTA0 & (1<<0)) == 0){}
  COMCON0 &= ~(1<<7);
  c=COMRX; /* f[^ǂݏo */
  return (char )c;
}

// 1M֐B
void putDebugChar (char ch){
  while ((COMSTA0 & (1<<6)) == 0){}
  COMCON0 &= ~(1<<7);
  COMTX =(unsigned int)ch;
}

void _illegalinst_func(void){
  gdb_handle_exception(EXCEPTION_ILL_INSN);
}

void _int_func(void){
  gdb_handle_exception(EXCEPTION_IRQ);
}

void _bus_func(void){
  gdb_handle_exception(EXCEPTION_DATA_ABORT);
}

void enable_EM0(){
  /* AhXb`EFCgFȂ
     [h/CgAT[gOEFCgF
     [h/CgANZXF4NbN */
  XM0PAR = 0x00000444;
  XM0CON = 0x3;	/* 16rbgoX */
}

void enable_EM1(){
  /* AhXb`EFCgFȂ
     [h/CgAT[gOEFCgF
     [h/CgANZXF4NbN */
  XM1PAR = 0x00000444;
  XM1CON = 0x1;	/* 8rbgoX */

}

void enable_EM2(){
  /* AhXb`EFCgFȂ
     [h/CgAT[gOEFCgF
     [h/CgANZXF1NbN */
  XM2PAR = 0x00000411;
  XM2CON = 0x3;	/* 16rbgoX */

}

void enable_EM3(){
  /* AhXb`EFCgFȂ
     [h/CgAT[gOEFCgF
     [h/CgANZXF1NbN */
  XM3PAR = 0x00000411;
  XM3CON = 0x3;	/* 16rbgoX */

}

void enable_XMCFG(){
  /* AhXoX/f[^oXI */
  GP0CON = (GP0CON & 0x0FFFF00F) | 0x10000220;
  GP2CON = (GP2CON & 0x0000000F) | 0x22222220;
  GP3CON = 0x22222222;
  GP4CON = 0x22222222;
  XMCFG = 1;
}
void cpu_init_at_main(){

  enable_EM0();
  enable_EM1();
  enable_EM2();
  enable_EM3();
  enable_XMCFG();
}





