#define PECRL1 *((volatile unsigned short *)0xFFFF83B8)
#define PACRL2 *((volatile unsigned short *)0xFFFF838E)
#define PEIORL *((volatile unsigned short *)0xFFFF83B4)
#define PEDRL *((volatile unsigned short *)0xFFFF83B0)
#define IPRF *((volatile unsigned short *)0xFFFF8352)
#define SCR0 *((volatile unsigned char *)0xFFFF81A2)
#define MSTCR1 *((volatile unsigned short *)0xFFFF861C)
#define SMR1 *((volatile unsigned char *)0xFFFF81B0)
#define BRR1 *((volatile unsigned char *)0xFFFF81B1)
#define SCR1 *((volatile unsigned char *)0xFFFF81B2)
#define SDCR1 *((volatile unsigned char *)0xFFFF81B6)
#define PBCR2 *((volatile unsigned short *)0xFFFF839A)
#define PCCR *((volatile unsigned short *)0xFFFF839C)
#define BCR1 *((volatile unsigned short *)0xFFFF8620)
#define BCR2 *((volatile unsigned short *)0xFFFF8622)
#define WCR1 *((volatile unsigned short *)0xFFFF8624)
#define PDCRL1 *((volatile unsigned short *)0xFFFF83AC)
#define PACRL1 *((volatile unsigned short *)0xFFFF838C)

void trap33_exception_func(){
  PEDRL &= 0x7FFF;
}

void trap34_exception_func(){
  PEDRL |= (1<<15);
}

int ITER1 = 500000;
int ITER2 = 100000;


#define EX_SRAM_START 0x400000
#define EX_SRAM_END 0x47ffff
#define EX_SRAM_SIZE (512*1024)

void _init_cs1(void)
{
  volatile unsigned char *cp;
  int i;
  
  PBCR2 = 0x2005; /* A18,A17,A16$B$rM-8z(B */
  PCCR = 0xFFFF; /* A15-A0$B$rM-8z(B */
  BCR1 |= 0x0002; /* CS1$B$O(B16bit$B6u4V(B */
  BCR2 &= 0xFEDD; /* IW1=CW1=SW1=0 */
  WCR1 &= 0xFF1F; /* CS1 1wait */
  PDCRL1 = 0xFFFF; /* D0-D15$B$rM-8z(B */
  PACRL1 = 0x1540; /* RD,WRH,WRHL,CS1$B$rM-8z(B */
  
  /* $B30It(BSRAM$B$r#0%/%j%"(B */
  cp = (unsigned char *)EX_SRAM_START;
  for ( i=0; i < EX_SRAM_SIZE ; i++) {
    *cp++ = 0x00;
  } 
}

int main(){
  volatile int i,j;
  // LED$B$NE@LG(B
  PECRL1 &= 0x0FFF;
  PEIORL |= (1<<15);
  PEDRL = (1<<15);

  for(j=0;j<20;j++){
    for(i=0;i<ITER1;i++);
    asm volatile ("trapa #33");
    for(i=0;i<ITER2;i++);
    asm volatile ("trapa #34");
  }
  return 0;
}

